function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

var styles = {"container":"_1Lxpd","cardCarousel":"_3tZKZ","card":"_xsi02","active":"_3sodH","next":"_1uQwZ","prev":"_KqFRp"};

var defaultCardItems = [/*#__PURE__*/React__default.createElement("div", {
  key: "key1"
}, /*#__PURE__*/React__default.createElement("h2", null, "First Item"), /*#__PURE__*/React__default.createElement("p", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit.")), /*#__PURE__*/React__default.createElement("div", {
  key: "key2"
}, /*#__PURE__*/React__default.createElement("h2", null, "Second Item"), /*#__PURE__*/React__default.createElement("p", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit.")), /*#__PURE__*/React__default.createElement("div", {
  key: "key3"
}, /*#__PURE__*/React__default.createElement("h2", null, "Third Item"), /*#__PURE__*/React__default.createElement("p", null, "Lorem ipsum dolor sit amet, consectetur adipiscing elit."))];

var setCardStatus = function setCardStatus(indexes, cardIndex) {
  if (indexes.currentIndex === cardIndex) {
    return styles.active;
  } else if (indexes.nextIndex === cardIndex) {
    return styles.next;
  } else if (indexes.previousIndex === cardIndex) {
    return styles.prev;
  }

  return styles.inactive;
};

var StackedCarousel = function StackedCarousel(_ref) {
  var onCardChange = _ref.onCardChange,
      containerClassName = _ref.containerClassName,
      cardClassName = _ref.cardClassName,
      _ref$leftButton = _ref.leftButton,
      leftButton = _ref$leftButton === void 0 ? "<" : _ref$leftButton,
      _ref$rightButton = _ref.rightButton,
      rightButton = _ref$rightButton === void 0 ? ">" : _ref$rightButton,
      _ref$autoRotate = _ref.autoRotate,
      autoRotate = _ref$autoRotate === void 0 ? true : _ref$autoRotate,
      children = _ref.children;
  var cardItems = children || defaultCardItems;

  var _useState = React.useState({
    previousIndex: cardItems.length - 1,
    currentIndex: 0,
    nextIndex: 1
  }),
      indexes = _useState[0],
      setIndexes = _useState[1];

  var handleCardTransition = React.useCallback(function () {
    if (indexes.currentIndex >= cardItems.length - 1) {
      setIndexes({
        previousIndex: cardItems.length - 1,
        currentIndex: 0,
        nextIndex: 1
      });
    } else {
      setIndexes(function (prevState) {
        return {
          previousIndex: prevState.currentIndex,
          currentIndex: prevState.currentIndex + 1,
          nextIndex: prevState.currentIndex + 2 === cardItems.length ? 0 : prevState.currentIndex + 2
        };
      });
    }
  }, [indexes.currentIndex]);
  var handleLeftButton = React.useCallback(function () {
    if (indexes.currentIndex <= 0) {
      setIndexes({
        previousIndex: cardItems.length - 2,
        currentIndex: cardItems.length - 1,
        nextIndex: 0
      });
    } else {
      setIndexes(function (prevState) {
        return {
          nextIndex: prevState.currentIndex,
          currentIndex: prevState.currentIndex - 1,
          previousIndex: prevState.currentIndex - 1 <= 0 ? cardItems.length - 1 : prevState.currentIndex - 2
        };
      });
    }
  }, [indexes.currentIndex]);
  React.useEffect(function () {
    onCardChange(indexes);
    var transitionInterval = setInterval(function () {
      autoRotate && handleCardTransition();
    }, 2000);
    return function () {
      return clearInterval(transitionInterval);
    };
  }, [handleCardTransition, indexes, autoRotate]);
  console.log(indexes);
  return /*#__PURE__*/React__default.createElement("div", {
    className: "" + styles.container
  }, /*#__PURE__*/React__default.createElement("span", {
    onClick: handleLeftButton
  }, leftButton), /*#__PURE__*/React__default.createElement("ul", {
    className: styles.cardCarousel + " " + containerClassName
  }, cardItems.map(function (card, index) {
    return /*#__PURE__*/React__default.createElement("li", {
      key: card.key,
      className: cardClassName + " " + styles.card + " " + setCardStatus(indexes, index)
    }, card);
  })), /*#__PURE__*/React__default.createElement("span", {
    onClick: handleCardTransition
  }, rightButton));
};

exports.StackedCarousel = StackedCarousel;
//# sourceMappingURL=index.js.map
